* O070-001-H001 (ASR33IOL)   DRAWING NO. 41286032-001-01
*
*
*
* COMPUTER:  H316, DDP-516
*
*
* PROGRAM CATEGORY:  INPUT/OUTPUT
*
*
* PROGRAM TITLE:  ASR33IOL
*                 ASR 33 FORTRAN AND STANDARD INPUT/OUTPUT LIBRARY USING
*                 IOBUS
*
*
*
*
*
*
*
*
*
*
*                            APPROVAL                          DATE
*
*  
*   
*                            PROG----------------------    ------------
*
*
*                            SUPR----------------------    ------------
*
*
*                            QUAL----------------------    ------------
*
*
*                                          NO. OF PAGES
*
*
* AUTHOR   
* 
*    HONEYWELL - COMPUTER CONTROL DIVISION (EUROPE)
*
*
* PURPOSE   
*
*    TO PROVIDE AN ASR 33 FORTRAN AND STANDARD INPUT/OUTPUT LIBRARY
*    USING IOBUS
*
*  
* RESTRICTIONS   
*   
*    THIS LIBRARY WILL WORK ON AN H316 OR DDP-516 COMPUTER WITH AN
*    ASR 33
*
*
* STORAGE   
*
*    SEE CONTENTS
*
*
* CONTENTS
*
*    MODULE                                              STORAGE   PAGE
*    NAME    DEFINITION                                  OCT  DEC  NO.
*
*    F$R1    FORTRAN READ FROM ASR                        30   24
*
*    F$W1    FORTRAN OUTPUT ON ASR
*    F$AL    FORTRAN ASR LINES/PAGE                       74   60
*
*    P$B1    FORTRAN REWIND ASR
*    F$F1    FORTRAN BACKSPACE ASR                         6    6
*
*    O$HA    ASR LIST HEADING                              4    4
*
*    O$GHAP  GENERAL HEADING ASR/HSP
*    O$ALHB  ASR LIST HEADING BUFFER
*    O$PLHB  HSP LIST HEADING BUFFER
*    O$ALPB  ASR LIST PAGE NUMBER BUFFER
*    O$PLPB  HSP LIST PAGE NUMBER BUFFER
*    O$ALPN  ASR LIST PAGE NUMBER
*    O$PLPN  HSP LIST PAGE NUMBER
*    O$ALLC  ASR LIST LINE COUNT/PAGE
*    O$PLLC  HSP LIST LINE COUNT/PAGE
*    O$ALLN  ASR LIST LINE NUMBER
*    O$PLLN  HSP LIST LINE NUMBER                         70   56
*       
*    O$AE    ASR LIST EJECT PAGE                          44   36
*       
*    O$LL    ASR LIST                                     26   22
*       
*    O$AE    ASR LIST EJECT PAGE                           2    2
*    (THIS IS A DEFAULT MODULE)
*       
*    O$ALHB  ASR LIST HEADING BUFFER
*    O$ADHB  ASR DEFAULT HEADING BUFFER
*    O$ALPB  ASR LIST PAGE NUMBER BUFFER                  44   36
*    (THIS IS A DEFAULT MODULE)
*       
*    O$ALLC  ASR LIST LINE COUNT/PAGE
*    O$ADLC  ASR DEFAULT LINE COUNT/PAGE
*    O$ALLN  ASR LIST LINE NUMBER
*    O$ADLN  ASR DEFAULT LINE NUMBER                       2    2
*    (THIS IS A DEFAULT MODULE)
*       
*    O$ALPN  ASR LIST PAGE NUMBER
*    O$ADPN  ASR DEFAULT PAGE NUMBER                       2    2
*    (THIS IS A DEFAULT MODULE)
*   
*    O$AP    ASR PRINT ROUTINE                            10    8
*
*    O$ALL   ASR LIST LINE                                24   20
*   
*    O$AC    ASR OUTPUT CARRIAGE RETURN                    6    6
*       
*    O$AF    ASR OUTPUT LINE FEED                          6    6
*       
*    I$AA    ASR INPUT SOURCE RECORD
*    I$AAE   ASR INPUT SOURCE RECORD                      50   40
*
*    O$AA    ASR OUTPUT SOURCE RECORD
*    O$AAE   ASR OUTPUT SOURCE RECORD                     32   26
*       
*    O$AS    ASR OUTPUT END OF TEXT
*    O$ASS   ASR OUTPUT SOURCE END OF TEXT
*    O$ASE   ASR OUTPUT SOURCE END OF TEXT                16   14
*       
*    I$AB    ASR INPUT OBJECT LINK                        14   12
*
*    O$AB    ASR OUTPUT OBJECT LINK                       12   10
*       
*    O$ASO   ASR OUTPUT OBJECT END OF TEXT
*    F$D1    FORTRAN WRITE FILE MARK ASR                  14   12
*       
*    I$AO    ASR INPUT OBJECT                            102   66
*       
*    O$AO    ASR OUTPUT OBJECT                            36   30
*
*    O$ALDR  ASR PUNCH LEADER                             16   14
*       
*    I$AINT  ASR INITIALISE FOR INPUT
*    I$AK    ASR INPUT CHARACTER                          14   12
*       
*    I$AT    ASR TIMING DELAY (ASR 33)                    12   10
*       
*    O$AINT  ASR INITIALISE FOR OUTPUT (ASR 33)            2    2
*
*    O$AK    ASR OUTPUT CHARACTER                         10    8
*
*
* USE
*   
*    INTERNAL MODULES  
*
*    NAME    CALLING SEQUENCE              CALLS   ERRORS
*
*    F$R1    CALL  F$R1                    F$IO    EF   END OF FILE
*            DAC   FORMAT DESCRIPTOR LIST  I$AO          ERROR
*                  RETURN                  I$AA
*                                          F$ER
*
*    F$W1    CALL  F$W1                    F$IO    NONE
*            DAC   FORMAT DESCRIPTOR LIST  C$SW
*                  RETURN                  O$AO
*                                          O$AK   
*                                          O$ALL
*    (LINKED WITH F$AL)
*
*    F$AL    XAC   F$AL                            NONE
*    (LINKED WITH F$W1)
*
*    F$B1    CALL  F$B1                    F$ER    ID   ILLEGAL DEVICE
*                  RETURN
*    (IDENTICAL WITH F$F1)
*
*    F$F1
*    (SEE F$B1)
*
*    O$HH    CALL  O$HH                    O$GHAP  NONE
*            DAC   HEADING BUFFER          O$AE
*                  RETURN
*
*    O$GHAP  LDX   RETURN PARAMETER                NONE
*            CALL  O$GHAP
*            (RETURN PARAMETER POINTS TO
*             BUFFER POINTER AND RETURN
*             IS MADE  TO NEXT LOCATION)
*    (LINKED WITH O$ALHB, O$PLHB, O$ALPB, O$PLPB, O$ALPN, O$PLPN,
*     O$ALLC, O$PLLC, O$ALLN, O$PLLN)
*
*    O$ALHB  XAC   O$ALHB                          NONE
*    (SIMILARLY FOR O$PLHB)
*    (LINKED WITH O$GHAP, O$ALPB, O$PLPB, O$ALPN, O$PLPN, O$ALLC,
*     O$PLLC, O$ALLN, O$PLLN)
*
*    O$ALPB  XAC   O$ALPB                          NONE
*    (SIMILARLY FOR O$PLPB)
*    (LINKED WITH O$GHAP, O$ALHB, O$PLHB, O$ALPN, O$PLPN, DSALLC,
*     O$PLLC, O$ALLN, O$PLLN)
*
*    O$ALPN  XAC   O$ALPN                          NONE
*    (SIMILARLY FOR O$PLPN)
*    (LINKED WITH O$GHAP, O$ALHB, O$PLHB, O$ALPB, O$PLPB, O$ALLC,
*    O$PLLC, O$ALLN, O$PLLN)
*
*    O$ALLC  XAC   O$ALLC                          NONE
*    (SIMILARLY FOR O$PLLC)
*    (LINKED WITH O$GHAP, O$ALHB, O$PLHB, O$ALPB, O$PLPB, O$ALPN,
*     O$PLPN, O$ALLN, O$PLLN)
*
*    O$ALLN  XAC   O$ALLN                          NONE
*    (SIMILARLY FOR O$PLLN)
*    (LINKED WITH O$GHAP, O$ALHB, O$PLHB, O$ALPB, O$PLPB, DSALPN,
*     O$PLPN, O$ALLC, O$PLLC)
*
*    O$AE    CALL  O$AE                    O$AK    NONE
*                  RETURN                  C$BB
*                                          O$ALPB   
*                                          O$ALL   
*                                          O$ALHB   
*                                          O$ALPN   
*                                          O$ALLC
*                                          O$ALLN
*
*    O$LL    CALL  O$LL                    O$AE    NONE
*            DAC   BUFFER ADDRESS          O$AK
*                  RETURN                  O$ALL
*                                          O$ALLC
*                                          O$ALLN
*
*    O$AE    CALL  O$AE                            NONE
*                  RETURN
*    (THIS IS A DEFAULT MODULE)
*
*    O$ALHB  XAC   O$ALHB                          NONE
*    (THIS IS A DEFAULT MODULE)
*    (LINKED WITH O$ALPB DEFAULT MODULE)
*    (IDENTICAL WITH O$ADHB)
*
*    O$ADHB   
*    (SEE O$ALHB)
*
*    O$ALPB  XAC   O$ALPB                          NONE
*    (THIS IS A DEFAULT MODULE)
*    (LINKED WITH O$ALHB DEFAULT MODULE)
*
*    O$ALLC  XAC   O$ALLC                          NONE
*    (THIS IS A DEFAULT MODULE)
*    (LINKED WITH O$ALLN DEFAULT MODULE)
*    (IDENTICAL WITH O$ADLC)
*
*    O$ADLC   
*   (SEE O$ALLC)
*
*    O$ALLN  XAC   O$ALLN                          NONE
*    (THIS IS A DEFAULT MODULE)
*    (LINKED WITH O$ALLC DEFAULT MODULE)
*    (IDENTICAL WITH O$ADLN)
*
*    O$ADLN   
*    (SEE O$ALLN)
*
*    O$ALPN  XAC   O$ALPN                          NONE
*    (THIS IS A DEFAULT MODULE)
*    (IDENTICAL WITH O$ADRN)
*
*    O$ADPN
*    (SEE O$ALPN)
*
*    O$AP    CALL  O$AP                    O$ALL   NONE
*            DAC   BUFFER ADDRESS
*                  RETURN
*
*    O$ALL   LDX   MINUS NO. BUFFER WORDS  C$SW    NONE
*            CALL  O$ALL                   O$AK
*            DAC   BUFFER ADDRESS
*                  RETURN
*
*    O$AC    CALL  O$AC                    O$AK    NONE
*                  RETURN   
*
*    O$AF    CALL  O$AF                    O$AK    NONE
*                  RETURN   
*
*    I$AA    CALL  I$AA                    C$II    PE   PARITY ERROR
*            DAC   BUFFER ADDRESS          I$AINT
*                  END OF TEXT RETURN      I$AK
*                  NORMAL RETURN           C$IP
*                                          C$ER   
*                                          C$TF   
*                                          C$IF   
*                                          C$IT
*                                          I$AT
*    (IDENTICAL WITH I$AAE)
*
*    I$AAE   
*    (SEE I$AA)
*
*    O$AA    CALL  O$AA                    O$AINT  NONE
*            DAC   BUFFER ADDRESS          C$OI
*                  RETURN                  C$OP  
*                                          O$AK   
*                                          C$OE   
*    (IDENTICAL WITH O$AAE)
*
*    O$AAE   
*    (SEE O$AA)
*
*    O$AS    CALL  O$AS                    O$AINT  NONE
*                  RETURN                  C$OP  
*    (IDENTICAL WITH O$ASS AND O$ASE)      O$AK
*
*    O$ASS
*    (SEE O$AS)
*
*    O$ASE
*    (SEE O$AS)
* 
*    I$AB    CALL  I$AB                    I$AO    CK   CHECKSUM ERROR
*            DAC   BUFFER ADDRESS          C$ER
*                  END OF TEXT RETURN
*                  NORMAL RETURN  
*  
*    O$AB    CALL  O$AB                    O$AO    NONE
*            DAC   BUFFER ADDRESS
*                  RETURN   
*            (THE FIRST WORD OF THE BUFFER
*             CONTAINS THE  NUMBER OF DATA
*             WORDS FOLLOWING)
*   
*    O$ASO   CALL  O$ASO                   D$AINT  NONE
*                  RETURN                  O$AK  
*    (IDENTICAL WITH F$D1)
* 
*    F$D1   
*    (SEE O$ASO)
* 
*    I$AO    LDA   BUFFER ADDRESS          I$AINT  BL   BLOCK LENGTH
*            CALL  I$AO                    I$AK          ERROR
*                  END OF TEXT RETURN      C$ER
*                  NORMAL RETURN           I$AT
*                                          C$IS
*            A-REGISTER ON RETURN:-
*                 ZERO = CHECKSUM AGREED
*            NON-ZERO  = CHECKSUM VIOLATION
*
*    O$AO    LDX   MINUS NO. DATA WORDS    O$AINT  NONE
*            LDA   BUFFER\ADDRESS          O$AK
*            CALL  O$AO                    C$SI
*                  RETURN
*   
*    O$ALDR  CALL  O$ALDR                  O$AINT  NONE
*                  RETURN                  O$AK
*
*    I$AINT  CALL  I$AINT                  O$AK    NONE
*                  RETURN   
*    (LINKED WITH I$AK)
*   
*    I$AK    CALL  I$AK                            NONE
*                  RETURN   
*
*            A-REGISTER ON RETURN
*            EQUALS CHARACTER INPUT
*    (LINKED WITH I$AINT)
*   
*    I$AT    CALL  I$AT                            NONE
*                  RETURN   
*
*    O$AINT  CALL  O$AINT                          NONE
*                  RETURN   
*
*    O$AK    LDA   CHARACTER                       NONE
*            CALL  O$AK
*                  RETURN
*
*
*    EXTERNAL MODULES
*
*    NAME    DEFINITION
*
*    C$BB    CONVERT BINARY TO BCI
*
*    C$ER    CONTROL ERROR ROUTINE
*
*    C$IF    CHARACTER INPUT FILL
*
*    C$II    CHARACTER INPUT INITIALISE
*
*    C$IP    INPUT PARITY
*
*    C$IS    CONVERT FROM INVISIBLE TO 6 BIT CODE
*   
*    C$IT    CHARACTER INPUT TAB
*
*    C$OE    CHARACTER OUTPUT EXTRACT
*
*    C$OI    CHARACTER OUTPUT INITIALISE
*
*    C$OP    OUTPUT PARITY
*
*    C$SI    CONVERT FROM 6 BIT TO INVISIBLE CODE
*
*    C$SW    STRIP TRAILING WORDS
*
*    C$TF    TEST FRAME
*
*    F$ER    FORTRAN ERROR ROUTINE
*
*    F$IO    FORTRAN SCANNER AND CONVERSIONS
*
*
* ERRORS   
*
*    BL    BLOCK LENGTH ERROR
*    CK    CHECKSUM ERROR
*
*          THESE ERRORS ARE REPORTED THROUGH C$ER (CONTROL ERROR
*          ROUTINE).
*
*    EF    END OF FILE ERROR
*    ID    ILLEGAL DEVICE
*
*          THIS ERROR IS REPORTED THROUGH F$ER (FORTRAN ERROR ROUTINE).
*
*    PE    PARITY ERROR
*
*          THIS ERROR IS REPORTED THROUGH C$ER (CONTROL ERROR ROUTINE).
*
*    CONTINUATION AFTER ANY OF THE ABOVE ERRORS EXCEPT ID PROCESSES THE
*    NEXT RECORD. CONTINUATION AFTER AN ID ERROR RETURNS CONTROL TO
*    THE CALLING PROGRAM.
*
*
* METHOD   
*
*    THE MODULES ARE ORDERED SO THAT HIGHER LEVEL MODULES PRECEDE LOWER
*    LEVEL MODULES.
*
*    NO REGISTER PRESERVATION IS ATTEMPTED. IT IS ASSUMED THAT THE
*    MODULES C$IS, C$OP, C$SI, I$AK, AND O$AK WILL NOT USE THE
*    X-REGISTER.
*
*    THE FOLLOWING RECORD FORMAT IS ASSUMED:
*
*      SOURCE:
*
*          LINEFEED, TEXT, CARRIAGE RETURN, DC3, DEL
*
*          (DC3 AND DEL ARE ONLY ESSENTIAL FOR PAPERTAPE)
*          BLANK TAPE  ('00O OR '200) AND DEL ARE IGNORED. TAB
*          CHARACTERS ('134 OR '334) PROCESS SPACE CHARACTERS ('240) TO
*          A PREDETERMINED POSITION. CONTROL H ('210) CHARACTER
*          DELETES THE  PREVIOUS CHARACTER AND LEFT-ARROW ('137 OR '337)
*          DELETES THE CURRENT RECORD ENTIRELY AND PROCESSES THE NEXT
*          RECORD.
*          A CARRIAGE RETURN TERMINATES THE RECORD. ONLY TEXT
*          CHARACTERS ARE RELATED TO THE CONTENTS OF THE BUFFER. OTHER
*          CHARACTERS ARE FOR CONTROL ONLY. THE BUFFER LENGTH WITH
*          TAB POSITIONS IS PRE-SET (SEE C$CC, C$TC AND C$TT) BUT CAN BE
*          INITIALISED USING THE INITIALISATION MODULE (SEE C$IN).
*          CHARACTERS IN EXCESS OF THE BUFFER LENGTH ARE DISCARDED AND
*          EXCESS TAB CHARACTERS ARE CHANGED TO SPACES. THE BUFFER IS
*          POST FILLED WITH SPACES FOR INPUT.
*
*      OBJECT:*
*
*          SOH('201), DATA WORDS (UP TO 60), DC3, DEL
*
*          THE DATA WORDS ARE IN INVISIBLE FORMAT.
*          A CHECKSUM VALUE WHICH IS THE EXCLUSIVE OR OF ALL THE DATA
*          WORDS IS CALCULATED DURING OBJECT READ BUT ONLY ACTIONED
*          BY I$AB.
*
*      END OF TEXT RECORD:
*
*          END OF TEXT ('003 OR '203), DC3, DEL
*
*          NOTE THAT AN END OF TEXT CHARACTER IN ANY CHARACTER POSITION
*          WILL CAUSE THE END OF TEXT RETURN TO BE TAKEN.
*
*
*      ASR LISTING FORMAT IS SET AT 72 LINES PER PAGE OF WHICH 60 ARE
*      AVAILABLE FOR LISTING INCLUDING HEADING EXCEPT UNDER FORTRAN
*      CONTROL WHEN PAGENATION IS ACTIONED BY THE CALLING PROGRAM.
*
*      PARITY IS DETERMINED BY THE INPUT AND OUTPUT PARITY ROUTINES USED.
*
*
*
\EJCT
*
*
\SUBR\F$R1\FORTRAN READ FROM ASR
*
*
\CF5\\H316 AND DDP-516
\REL\\RELOCATABLE
*
*
F$R1\DAC*\**\RETURN PARAMETER
\CALL\F$IO\FORTRAN SCANNER AND CONVERSIONS
RETN\DAC\**\RETURN
RSTR\LDA*\RETN\RETURN
\STA\BUFF\BUFFER
\LDA\F$R1\RETURN PARAMETER
\SSP\\ADDRESS OF FORMAT
\STA\0\INDEX
\LDA*\0\FORMAT
\SZE\\TEST FOR FORMAT
\JMP\FRED\FORMATTED READ
*
* UNFORMATTED READ  
\LDA\BUFF\BUFFER
\CALL\I$AO\ASR INPUT OBJECT
\JMP\EROR\ERROR
EXIT\IRS\RETN\RETURN
\JMP*\RETN\RETURN
*
* FORMATTED READ  
FRED\CALL\I$AA\ASR INPUT SOURCE RECORD
BUFF\BSZ\1\BUFFER
\JMP\EROR\ERROR
\JMP\EXIT\EXIT
*
* ERROR
EROR\CALL\F$ER\FORTRAN ERROR ROUTINE
\DAC\EFMG\END OF FILE MESSAGE
\JMP\RSTR\RESTART
*
*
* ERROR MNEMONIC  
*
EFMG\BCI\1,EF\END OF FILE MESSAGE
*
*
\END\\END OF F$R1 16.MAR.70 P.J.VYSE
